#include <thrust/iterator/zip_iterator.h>
#include <thrust/iterator/constant_iterator.h>
#include <thrust/device_vector.h>
#include <thrust/reduce.h>
#include <cstdio>
using namespace thrust;

typedef device_vector<int>::iterator IntIterator;
typedef device_vector<char>::iterator CharIterator;
typedef tuple<IntIterator, CharIterator> TupleIterator;


int main(){
	device_vector<int> A(3);
	device_vector<char> B(3);

	A[0] = 10;
	A[1] = 20;
	A[2] = 30;

	B[0] = 'x';
	B[1] = 'y';
	B[2] = 'z';

	zip_iterator<TupleIterator> first = make_zip_iterator(make_tuple(A.begin(), B.begin()));
	zip_iterator<TupleIterator> last = make_zip_iterator(make_tuple(A.end(), B.end()));

	maximum<tuple<int, char> > binary_op;
	tuple<int, char> init = first[0];

	tuple<int, char> ans = reduce(first, last, init, binary_op);

	printf("%d %c\n", ans.get<0>(), ans.get<1>());
	return 0;
}
